#!/usr/bin/env python
##################################################
# c2007-2009 by Paul Sherman <psherma1@rochester.rr.com> http://www.pcbypaul.com
#									        
# This program is free software; you can redistribute it and/or			
# modify it under the terms of the GNU General Public License			
# as published by the Free Software Foundation; either version 3		
# 										
# This program is distributed in the hope that it will be useful,		
# but WITHOUT ANY WARRANTY; without even the implied warranty of		
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			
# GNU General Public License for more details.					
#										
# You should have received a copy of the GNU General Public License		
# along with this program; if not, write to the Free Software			
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.   
#################################################
##  importing with system requirement checks #################

import sys, os, commands, string
import pygtk
import gobject
if gobject.pygtk_version < (2,5,9):
    print >>sys.stderr, "pyGTK version 2.6 or greater is required for this application"
    raise SystemExit
import gtk
try:
	import pango
except:
	print >> sys.stderr, "Cannot load Pango"
	raise SystemExit
	
font_desc = pango.FontDescription()

bar_xpm = [
"735 46 241 2",
"  	c None",
". 	c #4A6983",
"+ 	c #9E383C",
"@ 	c #D60E0A",
"# 	c #F4C2C1",
"$ 	c #FFFFFF",
"% 	c #FEF9F9",
"& 	c #FAE4E4",
"* 	c #F2B8B6",
"= 	c #E66C6A",
"- 	c #D6130F",
"; 	c #DE3E3B",
"> 	c #F8DAD9",
", 	c #FCF0F0",
"' 	c #E25553",
") 	c #F8DBDA",
"! 	c #E56B69",
"~ 	c #F2B7B5",
"{ 	c #EB8A88",
"] 	c #D92421",
"^ 	c #DD3A37",
"/ 	c #DA2824",
"( 	c #DB302D",
"_ 	c #E35B58",
": 	c #F7D1D0",
"< 	c #F8D9D8",
"[ 	c #DB2F2B",
"} 	c #F5CAC9",
"| 	c #F1B1B0",
"1 	c #F9DCDB",
"2 	c #DA2622",
"3 	c #E1524F",
"4 	c #EFA6A4",
"5 	c #E35C59",
"6 	c #EA8785",
"7 	c #D71814",
"8 	c #E04D4A",
"9 	c #EA8482",
"0 	c #D81B17",
"a 	c #FAE6E6",
"b 	c #D6110D",
"c 	c #FDF7F7",
"d 	c #E97E7C",
"e 	c #D81C18",
"f 	c #E56765",
"g 	c #FEFAFA",
"h 	c #FBE8E7",
"i 	c #F9E0E0",
"j 	c #D81A16",
"k 	c #FAE5E5",
"l 	c #FAE2E2",
"m 	c #E14F4C",
"n 	c #E87A78",
"o 	c #E25754",
"p 	c #ED9694",
"q 	c #E46462",
"r 	c #DD3C39",
"s 	c #E04C49",
"t 	c #EE9F9D",
"u 	c #D71713",
"v 	c #EC9593",
"w 	c #F7D2D1",
"x 	c #F1ADAC",
"y 	c #ED9795",
"z 	c #F5C6C5",
"A 	c #F3B9B7",
"B 	c #D9211E",
"C 	c #F0A8A6",
"D 	c #DA2A26",
"E 	c #E77573",
"F 	c #EEA09E",
"G 	c #F2B4B3",
"H 	c #FCF1F1",
"I 	c #F6CCCC",
"J 	c #E87977",
"K 	c #F3BCBB",
"L 	c #FBEBEA",
"M 	c #FEFBFB",
"N 	c #FCF2F2",
"O 	c #EE9C9B",
"P 	c #ED9897",
"Q 	c #FDF4F4",
"R 	c #E35E5B",
"S 	c #DB2C28",
"T 	c #E35A57",
"U 	c #E87876",
"V 	c #E9817F",
"W 	c #F7D5D4",
"X 	c #FDF6F6",
"Y 	c #F5C4C3",
"Z 	c #DC322F",
"` 	c #EC908E",
" .	c #F9DCDC",
"..	c #FBEAE9",
"+.	c #EC9290",
"@.	c #D60F0B",
"#.	c #E66E6C",
"$.	c #FCEDED",
"%.	c #FBE9E8",
"&.	c #F1B0AF",
"*.	c #DF423F",
"=.	c #EA8684",
"-.	c #E7726F",
";.	c #F6CECE",
">.	c #F3BDBC",
",.	c #DB2D29",
"'.	c #E97F7D",
").	c #F6CDCD",
"!.	c #FEFEFE",
"~.	c #E4615E",
"{.	c #EFA5A3",
"].	c #E77471",
"^.	c #E46461",
"/.	c #FDF8F8",
"(.	c #DD3734",
"_.	c #FCEEEE",
":.	c #E87775",
"<.	c #F1B2B1",
"[.	c #D91F1C",
"}.	c #E77370",
"|.	c #F4BFBE",
"1.	c #EFA4A2",
"2.	c #EB8E8C",
"3.	c #F3BAB8",
"4.	c #DA2522",
"5.	c #E25956",
"6.	c #E04E4B",
"7.	c #E25855",
"8.	c #DC3330",
"9.	c #F8D7D6",
"0.	c #DF4542",
"a.	c #DE403C",
"b.	c #E46563",
"c.	c #F7D3D2",
"d.	c #FDF5F5",
"e.	c #DE3D3A",
"f.	c #FEFCFC",
"g.	c #F4BEBD",
"h.	c #F1AFAE",
"i.	c #DD3B38",
"j.	c #E04A47",
"k.	c #E9807E",
"l.	c #E35F5C",
"m.	c #FDF3F3",
"n.	c #EE9E9D",
"o.	c #EC918F",
"p.	c #D9201D",
"q.	c #D71410",
"r.	c #EC8F8D",
"s.	c #F0A7A5",
"t.	c #EC9492",
"u.	c #D71915",
"v.	c #E56866",
"w.	c #F8D8D7",
"x.	c #F2B3B2",
"y.	c #EA8583",
"z.	c #E4625F",
"A.	c #E35D5A",
"B.	c #F1ACAB",
"C.	c #FEFDFD",
"D.	c #F9DDDD",
"E.	c #ED9796",
"F.	c #EB8C8A",
"G.	c #F5C9C8",
"H.	c #F5C7C6",
"I.	c #F2B5B4",
"J.	c #DA2B27",
"K.	c #EB8B89",
"L.	c #E98280",
"M.	c #DC3532",
"N.	c #DE413D",
"O.	c #ED9998",
"P.	c #F6CBCA",
"Q.	c #EB8D8B",
"R.	c #FCEFEF",
"S.	c #D6100C",
"T.	c #F2B6B5",
"U.	c #DA2925",
"V.	c #F3BAB9",
"W.	c #D9221F",
"X.	c #F7D0CF",
"Y.	c #D81E1A",
"Z.	c #DA2723",
"`.	c #E56A68",
" +	c #DC3633",
".+	c #F1AEAD",
"++	c #FAE7E6",
"@+	c #FAE1E1",
"#+	c #F4C0BF",
"$+	c #FBECEB",
"%+	c #EC9391",
"&+	c #F4C1C0",
"*+	c #E87B79",
"=+	c #DC312E",
"-+	c #DC3431",
";+	c #D81D19",
">+	c #DF4441",
",+	c #F6CFCE",
"'+	c #F3BBBA",
")+	c #D71612",
"!+	c #D92320",
"~+	c #DB2E2A",
"{+	c #E77674",
"]+	c #EFA3A1",
"^+	c #DF4744",
"/+	c #F5C5C4",
"(+	c #E87D7B",
"_+	c #E15351",
":+	c #E25653",
"<+	c #E04946",
"[+	c #DF4340",
"}+	c #E56967",
"|+	c #E6716E",
"1+	c #F9DFDF",
"2+	c #D71511",
"3+	c #E04B48",
"4+	c #E1514E",
"5+	c #E66F6C",
"6+	c #DE3F3B",
"7+	c #F0AAA9",
"8+	c #E1504D",
"9+	c #EFA19F",
"0+	c #EE9B9A",
"a+	c #D81F1B",
"b+	c #F9DEDE",
"c+	c #E77572",
"d+	c #EE9D9C",
"e+	c #F0A8A7",
"f+	c #DF4845",
"g+	c #DD3835",
"h+	c #F6CBCB",
"i+	c #FBEDEC",
"j+	c #E25452",
"k+	c #DF4643",
"l+	c #D6120E",
"m+	c #FAE3E3",
"n+	c #EA8886",
"o+	c #EB8987",
"p+	c #F5C8C7",
"q+	c #E98381",
"r+	c #EFA2A0",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
"+ + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ # $ $ $ $ $ $ $ % & * = - @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ; > , ' @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ) $ $ $ $ $ ! @ @ @ @ @ @ @ ~ $ $ $ $ $ { @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ] ^ $ $ $ ~ / ( _ : $ $ < [ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ } $ $ | @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ } $ $ | @ @ @ @ @ 1 $ $ ~ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ 2 3 $ $ $ $ 4 @ @ @ @ @ @ 5 $ $ $ $ 6 / 7 @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ 8 $ $ $ 9 @ @ @ 0 a $ $ < - @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ b c $ $ d @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ b c $ $ d @ @ @ @ e $ $ $ { @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ f g h $ $ i @ @ @ @ @ j k l $ $ $ m @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ n $ $ $ o @ @ @ @ p $ $ $ q @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ r $ $ $ s @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ r $ $ $ s @ @ @ @ @ t % | u @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ v w x $ $ $ / @ @ @ @ y z A $ $ $ B @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ C $ $ $ D @ @ @ @ E $ $ $ F @ @ @ @ _ G a g H I J - @ @ @ @ b f K L M N : O s @ P Q Q Q Q R @ @ S Q Q Q T @ @ U $ $ $ $ { V W c X Y Z B `  .% ..+.@.@ @ @ @ - #.# $.M %.&.*.@ @ @ U $ $ $ $ =.-.;.Q X >.,.@ @ @ k $ $ $ $ $ $ H @ @ @ @ 0 '.).Q !.c l ~.@ @ k $ $ $ $ $ $ H @ @ @ @ @ @ @ @ @ @ @ @ _ G a g H I J - @ @ U $ $ $ $ =.-.;.Q X >.,.@ @ @ @ @ @ @ @ @ @ @ @ # {.].$ $ $ ^.@ @ @ ; /.(.k $ $ a @ @ @ @ @ - #.# $.M %.&.*.@ @ @ U $ $ $ $ =.-.;.Q X >.,.@ @ @ P Q Q Q Q R @ @ S Q Q Q T @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ W $ $ _.@ @ @ @ @ :.$ $ $ <.@ @ [.# $ M }.[ 6 $ $ |.b @ @ 2 ;.$ $ 1.; ( 2.$ 3.@ 4.].$ $ $ (.@ @ 5.$ $ $ Z @ @ e 6.$ $ $ l 7.8.9.$ $ < |.0.a.Q $ $ b.@ @ @ D c.$ d._ e.& $ f.T @ @ e 6.$ $ $ 9.T ( g.$ $ K @ @ @ ^ h.$ $ & i.i.Z @ @ @ j.h M k.8.i $ $ l.@ @ ^ h.$ $ & i.i.Z @ 9.Q Q Q m.e @ @ @ [.# $ M }.[ 6 $ $ |.b @ e 6.$ $ $ 9.T ( g.$ $ K @ @ @ @ @ @ @ @ @ @ @ @ _.:.i.$ $ $ n.@ @ @.;.o.p.$ $ $ A @ @ @ @ D c.$ d._ e.& $ f.T @ @ e 6.$ $ $ 9.T ( g.$ $ K @ @ @ 4.].$ $ $ (.@ @ 5.$ $ $ Z @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ q.M $ $ # @ @ @ @ @ r.$ $ $ s.@ q.: $ $ t.@ @ u.$ $ $ v.@ u w.$ $ x.@ @ @ @.%.{ @ @ 6 $ $ /.b @ @ y.$ $ d.@.@ @ @ z.$ $ $ A.@ @ B.$ $ C.Z @ @ D.$ $ E.@ @ 7 ) $ $ F.@ @ 1.$ $ G.@ @ @ z.$ $ $ q @ @ '.$ $ H @ @ @ @ H.$ $ I.@ @ @ @ @ 6.% $ z.@ @ ..$ $ 8.@ @ @ H.$ $ I.@ @ @ @ [ &.$ $ D.@ @ @ q.: $ $ t.@ @ u.$ $ $ v.@ @ z.$ $ $ q @ @ '.$ $ H @ @ @ @ @ @ @ @ @ @ @ J.$ j.@., $ $ < @ @ E & u.8 $ $ $ K.@ @ @ 7 ) $ $ F.@ @ 1.$ $ G.@ @ @ z.$ $ $ q @ @ '.$ $ H @ @ @ @ 6 $ $ /.b @ @ y.$ $ d.@.@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ e.$ $ $ v @ @ @ @ @ x.$ $ $ L.@ L.$ $ $ M.@ @ j $ $ $ {.@ =.$ $ $ N.@ @ @ @ O.j.@ @ I.$ $ : @ @ @ | $ $ P.@ @ @ @ Q.$ $ R.S.@ @ Y $ $ z @ @ @ Q $ $ v @ @ =.$ $ $ e.@ @ T.$ $ w @ @ @ Q.$ $ m.- @ @ y $ $ R.@ @ @ @ m.$ $ 6 @ @ @ @ U., $ V.@ @ W.$ $ X S.@ @ @ m.$ $ 6 @ @ @ @ @ X.$ $ B.@ @ @ L.$ $ $ M.@ @ j $ $ $ {.@ @ Q.$ $ m.- @ @ y $ $ R.@ @ @ @ @ @ @ @ @ @ @ o $ Y.@ 3.$ $ $ W.Z.N _ @ n $ $ $ R @ @ @ =.$ $ $ e.@ @ T.$ $ w @ @ @ Q.$ $ m.- @ @ y $ $ R.@ @ @ @ I.$ $ : @ @ @ | $ $ P.@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ `.$ $ $ v.@ @ @ @ @ %.$ $ $ 0.@ a $ $ k @ @ @  +$ $ $ .+@ ++$ $ ++@ @ @ @ @ @ @ @ @ @+$ $ 4 @ @ @  .$ $ n.@ @ @ @ A $ $ #+@ @ @ $+$ $ %+@ @ J.$ $ $ -.@ @ a $ $ N @.@ W.Q $ $ 6 @ @ @ A $ $ &+@ @ @ &+$ $ I @ @ @ ( $ $ $ T @ @ @ @ x $ $ f @ @ s $ $ ;.@ @ @ ( $ $ $ T @ @ @ @ q.g $ $ *+@ @ @ a $ $ k @ @ @  +$ $ $ .+@ @ A $ $ &+@ @ @ &+$ $ I @ @ @ @ @ @ @ @ @ @ @ y.l @ @ V $ $ $ A.&.3.@ @ C $ $ $ =+@ @ @ a $ $ N @.@ W.Q $ $ 6 @ @ @ A $ $ &+@ @ @ &+$ $ I @ @ @ @ @+$ $ 4 @ @ @  .$ $ n.@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ E.$ $ $ i.@ @ @ @ ^ $ $ $ a b 8.$ $ $ &.@ @ @ z.$ $ $ Q.-+$ $ $ <.@ @ @ @ @ @ @ @ ;+$ $ $ J @ @ 7 !.$ $ -.@ @ @ @ & $ $ v @ @ ] $ $ $ f @ @ ' $ $ $ >+@ Z $ $ $ H.S.>+,+$ $ '+)+@ @ @ & $ $ v @ @ @ $+$ $ t @ @ @ l.$ $ $ ,.@ @ @ !+C.$ $ ~+@ @ {+$ $ ]+@ @ @ l.$ $ $ ,.@ @ @ @ a.$ $ $ j.@ @ 8.$ $ $ &.@ @ @ z.$ $ $ Q.@ @ & $ $ v @ @ @ $+$ $ t @ @ @ @ @ @ @ @ @ @ @ <.I.@ @ ^+$ $ $ w c ~+@ @ W $ $ m.@.@ @ Z $ $ $ H.S.>+,+$ $ '+)+@ @ @ & $ $ v @ @ @ $+$ $ t @ @ @ ;+$ $ $ J @ @ 7 !.$ $ -.@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ /+$ $ g - @ @ @ @ +.$ $ $ (+@ _+$ $ $ =.@ @ @ y $ $ $ 8 :+$ $ $ F.@ @ @ @ @ @ @ @ <+$ $ $ 6.@ @ [+$ $ $ 0.@ @ @ Y.$ $ $ }+@ @ m $ $ $ r @ @ k.$ $ C.u.@ ' $ $ $ f.f.$ ++&.T @ @ @ @ Y.$ $ $ `.@ @ ] $ $ $ -.@ @ @ Q.$ $ , @ @ @ @ A.$ $ H @ @ @ 1.$ $ :.@ @ @ Q.$ $ , @ @ @ @ @ |+$ $ !.j @ @ _+$ $ $ =.@ @ @ y $ $ $ 8 @ Y.$ $ $ `.@ @ ] $ $ $ -.@ @ @ @ @ @ @ @ @ @ @ 1+6 @ @ 2+% $ $ $ 9 @ @ q.M $ $ G.@ @ @ ' $ $ $ f.f.$ ++&.T @ @ @ @ Y.$ $ $ `.@ @ ] $ $ $ -.@ @ @ <+$ $ $ 6.@ @ [+$ $ $ 0.@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ , $ $ c.@ @ @ @ 2 m.$ $ : - @ 3+$ $ $ ! @ @ @ < $ $ 9.@ 4+$ $ $ n @ @ @ @ J ].@ @ 5+$ $ $ Z.@ @ d $ $ !.j @ @ @ <+$ $ $ 6+@ @ J $ $ f.q.@ @ 7+$ $ 1 @ @ _+$ $ $ V / )+@ @ 7 ] S.@ @ <+$ $ $ 6+@ @ 8+$ $ $ >+@ @ @ 3.$ $ /+@ @ @ @ E $ $ w @ @ @ D.$ $ s @ @ @ 3.$ $ /+@ @ @ @ @ 9+$ $ > @ @ @ 3+$ $ $ ! @ @ @ < $ $ 9.@ @ <+$ $ $ 6+@ @ 8+$ $ $ >+@ @ @ @ @ @ @ @ @ @ 0 !._ @ @ @ H.$ $ 1 q.@ @ e.$ $ $ 0+@ @ @ _+$ $ $ V / )+@ @ 7 ] S.@ @ <+$ $ $ 6+@ @ 8+$ $ $ >+@ @ @ 5+$ $ $ Z.@ @ d $ $ !.j @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ~+$ $ $ 4 @ @ @ j z $ $  .D @ @ u.N $ $ #.@ @ [+$ $ /.*.@ a+/.$ $ ` @ @ @ N.!.b.@ @ |+$ $ $ q.@ b > $ $ b+@ @ @ @ c+$ $ f.)+@ @ 1.$ $ w.@ @ @ W $ $ .+@ @ ] f.$ $ n @ @ @ - ,+;.@.@ @ c+$ $ f.)+@ @ n $ $ C.u.@ @ @  .$ $ d+@ *.k ^ q $ $ I @ @ [+$ $ $ p.@ @ @  .$ $ d+@ *.k ^ @ w $ $ e+@ @ @ u.N $ $ #.@ @ [+$ $ /.*.@ @ c+$ $ f.)+@ @ n $ $ C.u.@ @ @ @ @ @ @ @ @ @ f+$ ~+@ @ @ L.k k m @ @ @ `.$ $ $ #.@ @ @ ] f.$ $ n @ @ @ - ,+;.@.@ @ c+$ $ f.)+@ @ n $ $ C.u.@ @ @ |+$ $ $ q.@ b > $ $ b+@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ q./ `.$ $ $ { / g+|+1+$ !.C [.@ @ @ @ v.!.$ h+ +<+ .$ L 6.@ @ @ U $ $ i+j+,.^.L P @ @ @ ^ $ $ $ -.k+]+R.$ $ Y i.b @ @ F $ $ > @ @ @ ;.$ $ B.@ @ l+g $ $ o.] @ @ o.$ $ m+4+,.m H.D.S @ @ @ F $ $ > @ @ @ {.$ $ @+/ q.@ @ ,+$ $ &. +z P.@ [., $ c s 6+w $ $ $+/ S.@ @ ,+$ $ &. +z P.@ 2+M $ $ n+!+@ @ @ v.!.$ h+ +<+ .$ L 6.@ @ @ F $ $ > @ @ @ {.$ $ @+/ q.@ @ @ @ @ @ @ u / L.d.U.p.@ @ @ @ @ @ @ j / F $ $ $ o Z.@ @ @ o.$ $ m+4+,.m H.D.S @ @ @ F $ $ > @ @ @ {.$ $ @+/ q.@ @ ^ $ $ $ -.k+]+R.$ $ Y i.b @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ }+$ $ $ $ $ $ $ /.h # o+( @ @ @ @ @ @ @ <+I...M , } V a+@ @ @ @ @ _+V.$+M _.>.T @ @ @ @ @ |+l M h e+=+d.$ $ $ d.S.@ @ h+$ $ .+@ @ @.X $ $ V @ @ g+$ $ $ $ p+@ @ @ v.H.H f._.H.*+7 @ @ @ @ h+$ $ .+@ @ @ ,+$ $ $ $ ( @ @ 3+).d.f.h s.] @ @ *.G./., | q+$ $ $ /.- @ @ 3+).d.f.h s.] @ N.$ $ $ $ K @ @ @ @ <+I...M , } V a+@ @ @ @ h+$ $ .+@ @ @ ,+$ $ $ $ ( @ @ @ @ @ @ @ L.$ $ $ $ F @ @ @ @ @ @ @ r+$ $ $ $ $ $ & @ @ @ @ v.H.H f._.H.*+7 @ @ @ @ h+$ $ .+@ @ @ ,+$ $ $ $ ( @ @ @ |+l M h e+=+d.$ $ $ d.S.@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"@ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ ",
"+ + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              "]

close_xpm = [
"32 32 32 1",
" 	c None",
".	c #D5A7A5",
"+	c #DFBBBB",
"@	c #F0D0CF",
"#	c #FAD9D8",
"$	c #F7E3E3",
"%	c #CA8C8C",
"&	c #DD9E9E",
"*	c #C77878",
"=	c #EDB8B8",
"-	c #CD6F6E",
";	c #FDFFFC",
">	c #E08E8E",
",	c #BA5151",
"'	c #E88786",
")	c #D76868",
"!	c #B43E3A",
"~	c #E15B5A",
"{	c #D13334",
"]	c #A11B1C",
"^	c #EB7A79",
"/	c #D00000",
"(	c #E91C14",
"_	c #EC2F23",
":	c #E60000",
"<	c #C33F3F",
"[	c #ED4E4B",
"}	c #BC3532",
"|	c #B1090B",
"1	c #CF1E1F",
"2	c #ED3931",
"3	c #BA0001",
"                                ",
"    .+@@@@@@@@@###$$$$$$$$$+    ",
"   .+..............++++++++@#   ",
"  ..%%%%%%%%%&&%%&&&&&&.....@+  ",
" +*%%%%%%%%%%%%+.%&&&&&&&&&&&=+ ",
" +-%%****%%%%%@;;+>>>>>&&&&&&>+ ",
" +,***********$;;@'>>>>>>>>>&)+ ",
" +!*******--*-$;;@--*'>>>>>>>~+ ",
" +!*-*----%%--$;;=-.@.-'''''>{+ ",
" +]-----,+;;.)#;;=>;;;+-^^''~/+ ",
" +],,,,,+;;;#~#;;=';;;;+)^^^(/+ ",
" +],,,,%;;;$'~#;;=~>$;;;&~^_:/+ ",
" +],,!,$;;$)<~@;;=~~^$;;$~_:(/+ ",
" +]!!<%;;;'<~<#;;=[~[';;;^:((/+ ",
" +]!<}+;;#<<<<&;;'[[[[#;;&:((/+ ",
" +|}}}#;;&{<<{{^~[[[[[>;;#(((_+ ",
" +|}}}$;;>1{{{{{{{[[2(^;;$_(__+ ",
" +|}]}$;;>1{{{{{{{2(::^;;#_(_2+ ",
" +|]||=;;=1111112(::::=;;=(__2+ ",
" +|||3';;;<111///::::{;;;'(__2+ ",
" +|||3{;;;@3////::::(@;;;2__22+ ",
" +3|333';;;=1///:::1=;;;'(_222+ ",
" +3|3333=;;;$>{1_{'$;;;=(__222+ ",
" +3333333=;;;;;;;;;;;;=_(__222+ ",
" +3333333/^$;;;;;;;;$^((___222+ ",
" +3333333///~&#$$#=~_:((__2222+ ",
" +1|33333//////((:::((((___22[+ ",
"  !{|3333//////:::::(((((__2[!  ",
"   ![{{{{{2222222222222[[[[[!   ",
"    !!!!!!!!!!!!<<}}}}}}}}}!    ",
"                                ",
"                                "]

icon_xpm = [
"16 16 207 2",
"  	c None",
". 	c #0F307C",
"+ 	c #335296",
"@ 	c #325195",
"# 	c #2F4F93",
"$ 	c #2D4D92",
"% 	c #2C4B91",
"& 	c #2A4A90",
"* 	c #2A498F",
"= 	c #29498F",
"- 	c #2A4A8F",
"; 	c #2B4B90",
"> 	c #2D4C91",
", 	c #2F4E93",
"' 	c #315095",
") 	c #BED5FA",
"! 	c #B3C9F1",
"~ 	c #A8BFEA",
"{ 	c #9FB7E3",
"] 	c #98B1DE",
"^ 	c #92ABDA",
"/ 	c #8EA7D8",
"( 	c #8DA6D6",
"_ 	c #8DA7D7",
": 	c #91AAD9",
"< 	c #96AFDD",
"[ 	c #9CB6E2",
"} 	c #A5BEE7",
"| 	c #B0C7EF",
"1 	c #304F94",
"2 	c #305094",
"3 	c #A2BBE6",
"4 	c #97B0DE",
"5 	c #8EA7D7",
"6 	c #85A0D1",
"7 	c #7F9ACC",
"8 	c #7B96CA",
"9 	c #89A3DA",
"0 	c #7A95C9",
"a 	c #7E98CB",
"b 	c #839DCF",
"c 	c #8BA5D5",
"d 	c #95AEDC",
"e 	c #A0B8E3",
"f 	c #2C4C91",
"g 	c #A2BAE5",
"h 	c #94ADDB",
"i 	c #88A2D3",
"j 	c #7D98CA",
"k 	c #738FC4",
"l 	c #7896D7",
"m 	c #E0E8FF",
"n 	c #E6EEFF",
"o 	c #6784BB",
"p 	c #6B87BE",
"q 	c #728DC2",
"r 	c #859FD0",
"s 	c #29488F",
"t 	c #94AEDC",
"u 	c #86A0D2",
"v 	c #7894C8",
"w 	c #6D88BF",
"x 	c #627FB8",
"y 	c #6986C3",
"z 	c #FFFFFF",
"A 	c #5472AE",
"B 	c #5876B1",
"C 	c #607CB6",
"D 	c #6A86BD",
"E 	c #7690C6",
"F 	c #829DCF",
"G 	c #25458C",
"H 	c #28478E",
"I 	c #89A3D4",
"J 	c #7A94C9",
"K 	c #6A87BE",
"L 	c #5E7AB5",
"M 	c #5170AC",
"N 	c #4867A6",
"O 	c #4F6CAA",
"P 	c #4361A1",
"Q 	c #415FA0",
"R 	c #4665A4",
"S 	c #4F6DAA",
"T 	c #5B77B2",
"U 	c #6883BB",
"V 	c #7691C6",
"W 	c #22428A",
"X 	c #7F9ACD",
"Y 	c #6F8AC0",
"Z 	c #5E7BB6",
"` 	c #506DAB",
" .	c #4260A1",
"..	c #375699",
"+.	c #34559F",
"@.	c #3455A1",
"#.	c #2E4E93",
"$.	c #355498",
"%.	c #3F5E9F",
"&.	c #4C69A8",
"*.	c #5B78B3",
"=.	c #204088",
"-.	c #24438B",
";.	c #7793C7",
">.	c #6681BA",
",.	c #4362A2",
"'.	c #345397",
").	c #2B4B92",
"!.	c #F6F8FB",
"~.	c #27468F",
"{.	c #24448B",
"].	c #305095",
"^.	c #3F5EA0",
"/.	c #627DB7",
"(.	c #1E3E87",
"_.	c #728DC3",
":.	c #5F7CB6",
"<.	c #4C6AA8",
"[.	c #3B599C",
"}.	c #29468F",
"|.	c #F2F5FA",
"1.	c #0E307B",
"2.	c #153682",
"3.	c #365599",
"4.	c #4866A5",
"5.	c #5A77B2",
"6.	c #1C3D86",
"7.	c #214289",
"8.	c #6E8AC0",
"9.	c #5B78B2",
"0.	c #355497",
"a.	c #1D367B",
"b.	c #ECF1F5",
"c.	c #032674",
"d.	c #0B2D79",
"e.	c #1D3E87",
"f.	c #2F4F94",
"g.	c #5673B0",
"h.	c #1C3C85",
"i.	c #214189",
"j.	c #6E89C0",
"k.	c #4765A5",
"l.	c #345396",
"m.	c #204189",
"n.	c #1C367F",
"o.	c #ECF0F8",
"p.	c #032574",
"q.	c #082A78",
"r.	c #1B3C85",
"s.	c #4261A1",
"t.	c #5573AE",
"u.	c #6F8CC1",
"v.	c #5C79B4",
"w.	c #4968A6",
"x.	c #365699",
"y.	c #263E8A",
"z.	c #F4F7FB",
"A.	c #0F317D",
"B.	c #204188",
"C.	c #4563A3",
"D.	c #5875B1",
"E.	c #23438A",
"F.	c #7490C4",
"G.	c #617FB7",
"H.	c #506EAB",
"I.	c #23418D",
"J.	c #C4D0E5",
"K.	c #D3DCEC",
"L.	c #12347F",
"M.	c #3A599B",
"N.	c #4B69A7",
"O.	c #5D7AB5",
"P.	c #1D3D86",
"Q.	c #6A86BE",
"R.	c #5976B2",
"S.	c #4967A6",
"T.	c #2E4F93",
"U.	c #26468D",
"V.	c #22438B",
"W.	c #24458C",
"X.	c #375799",
"Y.	c #4564A3",
"Z.	c #5473AE",
"`.	c #6682BA",
" +	c #1F3F87",
".+	c #849ED0",
"++	c #748FC5",
"@+	c #6581BA",
"#+	c #39589A",
"$+	c #365598",
"%+	c #37569A",
"&+	c #3D5C9E",
"*+	c #5370AD",
"=+	c #607EB7",
"-+	c #708CC2",
";+	c #0C2E7A",
">+	c #1E3E86",
",+	c #1A3B84",
"'+	c #183882",
")+	c #163681",
"!+	c #143580",
"~+	c #13357F",
"{+	c #153681",
"]+	c #173882",
"^+	c #1A3A84",
"/+	c #204089",
"(+	c #0B2D7A",
". + @ # $ % & * = = - ; > , ' . ",
"+ ) ! ~ { ] ^ / ( _ : < [ } | 1 ",
"2 | 3 4 5 6 7 8 9 0 a b c d e f ",
"$ g h i j k l m n o p q 0 r : s ",
"& t u v w x y z z A B C D E F G ",
"H I J K L M N O P Q R S T U V W ",
"G X Y Z `  ...+.@.#.$.%.&.*.K =.",
"-.;.>.A ,.'.).!.z ~.{.].^.` /.(.",
"W _.:.<.[.= }.|.z 1.2.G 3.4.5.6.",
"7.8.9.4.0.W a.b.z c.d.e.f.,.g.h.",
"i.j.5.k.l.m.n.o.z p.q.r.# s.t.r.",
"W u.v.w.x.G y.z.z p.A.B.+ C.D.h.",
"E.F.G.H.%.#.I.J.K.L.6.& M.N.O.P.",
"{.8 Q.R.S.[.T.U.V.W.f X.Y.Z.`. +",
"U..+++@+g.w.%.#+$+%+&+k.*+=+-+i.",
";+G i.>+,+'+)+!+~+!+{+]+^+P./+(+"]

		
class ShowDocs:
		
	def get_doc_list(self=None, e=None):
		ff = os.listdir("/usr/doc")
		doclist = []
		for fdir in ff:
			if not fdir.lower().startswith("cups"):
				p = "/usr/doc/" + fdir + "/index.html"
				if os.path.exists(p):
					doclist.append(fdir)
		doclist.sort()
		return doclist
		
	def info(self, message):
		box = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, message)
		box.set_position(gtk.WIN_POS_CENTER)
		box.set_title('Information')
		box.run()
		box.destroy()	
		
	def alert(self, message):
		box = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, message)
		box.set_position(gtk.WIN_POS_CENTER)
		box.set_title('Error')
		box.run()
		box.destroy()		
		
	def change_size(self, evt=None):
		font_size = self.combo_size.get_active_text()
		font_desc.set_size(int(font_size) * 1024)
		self.f_display.modify_font(font_desc)

	def destroy(self, widget, data=None):
		gtk.main_quit()

	def delete_event(self, widget, event, data=None):
		gtk.main_quit()
	
	def doClose(self, w=None):
		gtk.main_quit()
	
	def makeChange(self, w=None):	
		app_name = self.combo.get_active_text()
		# fix possible multi-linestring (comma is a give-away...)
		try:
			font_name = string.split(font_name, ",")[1]
		except:
			pass
	
		doc_path = "/usr/doc/" + app_name + "/index.html"
		try:
			if os.path.exists(doc_path):
				os.system("runBrowser %s 2>/dev/null" % doc_path)
		except:
			pass
		# Our work here is done...	
		gtk.main_quit()

#####################################################
#####################################################
	def __init__(self, marg):
		self.window = None
		
		###########  close button, bar anf logo  ################
		bar = gtk.gdk.pixbuf_new_from_xpm_data(bar_xpm)
		closer = gtk.gdk.pixbuf_new_from_xpm_data(close_xpm)
		icon = gtk.gdk.pixbuf_new_from_xpm_data(icon_xpm)

		bar_img = gtk.Image()
		close_img = gtk.Image()
		self.txt_pix = gtk.Image()

		bar_img.set_from_pixbuf(bar)
		close_img.set_from_pixbuf(closer)

		###########  window setup  ################
		
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_title("Available HTML Documents")
		self.window.set_border_width(5)
		self.window.set_default_size(500, 160)
		self.window.set_position(gtk.WIN_POS_CENTER)
		self.window.set_geometry_hints(self.window, 500, 160, 640, 160)
		self.window.connect("delete_event", self.delete_event)
		self.tooltips = gtk.Tooltips()
		self.window.set_icon(icon)

		###########  layout  ################
		vbox = gtk.VBox(False, 16)
		self.window.add(vbox)

		###########  close and bar and logo ################
		top_box = gtk.HBox(False, 0)
		vbox.pack_start(top_box, False, True, 0)

		btn_close = gtk.Button()
		btn_close.add(close_img)
		btn_close.set_relief(gtk.RELIEF_NONE)
		
		btn_close.connect("clicked", self.doClose)
		self.tooltips.set_tip(btn_close, "CLOSE")

		top_box.pack_end(btn_close, False, False, 0)
		top_box.pack_start(bar_img, False, False, 0)
		
		###########  Lower boxes layout ########

		bot_box = gtk.HBox(True,0)
		vbox.pack_start(bot_box, False, False, 20)
		self.bot_L_box = gtk.VBox(False,8)
		self.bot_R_box = gtk.VBox(False,8)
		
		bot_box.pack_start(self.bot_L_box, True, True, 16)
		bot_box.pack_start(self.bot_R_box, False, False, 0)

		self.new_box = gtk.HBox(True, 0)
		vbox.pack_start(self.new_box, False, False, 0)	
			
		##########  left box setup  ###############

		#### Program Name combo box  ###
		self.combo = gtk.combo_box_new_text()

		flist = self.get_doc_list()
		for l in flist:
			self.combo.append_text(l)
		self.bot_L_box.pack_start(self.combo, False, False, 0)
		self.combo.child.modify_font(pango.FontDescription("sans 16"))
		self.combo.set_active(0)	

		self.view_doc = gtk.Button("View Documentation")
		self.bot_R_box.pack_start(self.view_doc, False, False, 0)
		self.view_doc.connect("clicked", self.makeChange)	
		set_txt_lbl = self.view_doc.get_children()[0]
		set_txt_lbl.set_markup('<span size="14000" foreground="#2D485F"><b>View Documentation</b></span>')
		self.tooltips.set_tip(self.view_doc, "Open the documentation")

		self.window.show_all()
		self.combo.grab_focus()

			
def main(argv):	
	ShowDocs(argv)
	gtk.main()
	
if __name__ == "__main__":
	main(sys.argv)
