#!/bin/sh
#
# ffSplash.sh
# uses xv for a splash screen for Firefox
# 2005-2008 by Paul Sherman 

height=$(echo  $(xwininfo  -root  |  \
      awk  'BEGIN  {FS=":"}  /Height/  {print $2}'))
width=$(echo  $(xwininfo  -root  |  \
      awk  'BEGIN  {FS=":"}  /Width/  {print $2}'))
	  
mleft=$[($width-500)/2]
mtop=$[($height-340)/2]

RANGE=4
name="/usr/share/pixmaps/ffSplash"
number=$RANDOM
let "number %= $RANGE"
nname=$name$number.png

if [ -r $nname ]; then
	xv -nodecor -cursor 150 -viewonly -geometry +$mleft+$mtop $nname &
	pid=$!
	sleep 1
fi

while [ ! `find "$HOME/.mozilla/firefox" -name "lock"` ]; do
	sleep 1
done

kill -kill $pid
exit 0
