#!/bin/sh
# fullscreen.sh
##################################################
# 2004-20014 by Paul Sherman
# for Absolute Linux
# <psherman2001@gmail.com> http://www.absolutelinux.org  
#									        
# This program is free software; you can redistribute it and/or			
# modify it under the terms of the GNU General Public License			
# as published by the Free Software Foundation; either version 3		
# 										
# This program is distributed in the hope that it will be useful,		
# but WITHOUT ANY WARRANTY; without even the implied warranty of		
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			
# GNU General Public License for more details.					
#										
# You should have received a copy of the GNU General Public License		
# along with this program; if not, write to the Free Software			
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.   
##################################################
DIALOG=Xdialog
$DIALOG --rc-file /usr/share/pixmaps/colorboxSM.rc  --icon /usr/share/pixmaps/tux.xpm  --title "Screenshot in 10 Seconds" \
	--help "\nThe screenshot is saved in your home folder\n as \"screenshot.png\", replacing \n \
	any previous screenshot.\n\n The image will then be opened \n automatically by viewnior.\n" \
	--yesno "\nThe screenshot will include the taskbar\n and any menus you have open.\n\n \
	There is a 10 second delay from the close of this dialog  \n to give you time to prepare. \n\n \
	Click \"Yes\" to continue with the screenshot.\n" 0 0
	
case $? in
  0)
    echo "Screenshot timer started";;
  1)
    exit 0;;
  255)
    exit 0;;
esac

sleep 10
xwd -root -out $HOME/screenshot.xwd
convert $HOME/screenshot.xwd $HOME/screenshot.png
viewnior $HOME/screenshot.png &
rm -f $HOME/screenshot.xwd
exit 0
