#!/usr/bin/env python
# version 2.0
#
# c2007-2015 by Paul Sherman <psherma1@rochester.rr.com> http://www.pcbypaul.com
#									        #
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
from Tkinter import *
import string, tkFileDialog, sys, os, tkMessageBox
import subprocess
root = Tk()
#
#
# Bail if needed Python version is not present
if sys.hexversion < 0x020200F0:
	tkMessageBox.showwarning("This version of Python is too old.\nAt least verison 2.2 is required.")
	sys.exit(1)
#
# declare my vars and paths, file i/o first...
mPath = ""
wholeThing = StringVar()
wholeThing.set("howdy")
radVar = StringVar()
radVar.set("pop3")

notThing = StringVar()
notThing.set("")
enVar = StringVar()
enVar.set("yes")

username=StringVar()
pword=StringVar()
servername=StringVar()
sndName=StringVar()
sndName.set("No Sound Selected")
sndBool=StringVar()
sndBool.set("off")
backupString=StringVar()
backupString.set("")
#
#
#
#before completing GUI, check for preferences file so we don't do a lot for nothing...
mHome = os.path.expanduser('~')
mPath = mHome + "/.icewm/preferences"
if os.path.exists(mPath):
	pass
else:
	tkMessageBox.showwarning("Missing Preferences File\n\nCheck your installation, or with your system admin... \nyour installation seems to be incomplete.")
	sys.exit()
#
#
#define functions for later use
# use setNotify as separate function for we can wasily turn off notification but leave other values
def setNotify(nBool):
	notThing.set("")
	try:
		f=open(mPath, 'r')
		for line in f.readlines():
			if string.find(line, "TaskBarShowMailboxStatus") > -1:
				if nBool == "no":
					notThing.set(notThing.get() + "TaskBarShowMailboxStatus=0 # 0/1\n")
				else:
					notThing.set(notThing.get() + "TaskBarShowMailboxStatus=1 # 0/1\n")
			else:
				notThing.set(notThing.get() + line)
		f.close()
		l=open(mPath, 'w')
		l.write(notThing.get())
		l.close()
	except IOError:
		tkMessageBox.showwarning("Error Opening File\n\nMaybe it is open...\nAnyway, cannot edit it now.")

def mValidate():
	# first, set notify or not -- bail after setting if not
	if enVar.get() == "no":
		setNotify("no")
		tkMessageBox.showinfo("Change set", "Email Notification has been turned off.")
		sys.exit()
	else:
		mStr = "x"
		newStr = ""
		newSndStr=""
		u = username.get()
		p = pword.get()
		s = servername.get()
		if s == "":
			mStr = "** No ServerName **"
		if p == "":
			mStr = "** No Password **"
		if u == "":
			mStr = "** No UserName **"	

		if mStr != "x":
			tkMessageBox.showwarning("Missing Input\n\n" + mStr)
		else:
			#ready to write out the new file
			#...let's back up the old one first.
			backupString.set(oldMailBoxPath + oldNewMailCommand + wholeThing.get())
			bakPath = mHome + "/.icewm/preferences.bak"
			try:
				m=open(bakPath, 'w')
				m.write(backupString.get())
				m.close()
			except IOError:
				tkMessageBox.showwarning("Error Opening File\n\nCannot bacup the original preferences file")
				sys.exit()
			#
			#backup complete. Now let's write the new preferences file...
			u = u.replace ('@', '%40')
			newStr = "MailBoxPath=\"" + radVar.get() + "://" + u + ":" + p + "@" + s + "/\"\n"
			if sndName.get() != "No Sound Selected":
				newSndStr = "NewMailCommand=\"play " + sndName.get() + "\"\n"
			wholeThing.set(newStr + newSndStr + wholeThing.get())
			try:
				l=open(mPath, 'w')
				l.write(wholeThing.get())
				l.close()
				cmd = 'killall -HUP icewm 2&>/dev/null'
				os.system(cmd)		
				tkMessageBox.showinfo("Changes set","Mailbox Notification Setup Complete")
			except IOError:
				tkMessageBox.showwarning("Error Opening File\n\nMaybe it is open...\nAnyway, cannot edit it now.")
			
			setNotify("yes")
			sys.exit()

def run_gmail():
	try:
		os.system("chmod a+x $HOME/.icewm/rc.gmail")
		subprocess.Popen(["/usr/bin/qgmailnotifier","&"])
		root.withdraw()
	except:
		pass
	sys.exit()

	
def findSound():
	WAVE_FILE_TYPE=[("Wave Files","*.wav")]
	fName = tkFileDialog.askopenfilename(filetypes=WAVE_FILE_TYPE, title="Choose a wave file", initialdir="/usr/share/sounds")
	if fName=='': return
	sndName.set(fName)

def testSnd():
	if sndName=='No Sound Selected': return
	os.system("play " + sndName.get())
	
def enableSound():
	if sndBool.get()=="off":
		bSound.config(state="disabled")
		bTest.config(state="disabled")
		sndName.set("No Sound Selected")
	else:
		bSound.config(state="active")
		bTest.config(state="active")
		if oldWav != "":
			sndName.set(oldWav)
#
#Setup GUI
#
# routine to center root window  on screen
scrX, scrY = root.winfo_screenwidth(), root.winfo_screenheight()
wStart = (scrX - 400) / 2
hStart = (scrY - 500) / 2
root.geometry("%dx%d%+d%+d" % (400, 500, wStart, hStart))
#
#below is the base64 rendition of the mail notification GIF
photo="""R0lGODdhDwALAMYAANyTHO+0Ve6yUe6yUu6yU+6yVO6zUfK3UYlEAOWuR////////v//8v//6f//
3v//0v//x///vv//rP/7kXk7APn2pvv40f//+v//7///2v//zf//uf//mf/6h/DSPteqD3g6AOWu
Vfn21fLlYvXvlf//6///0///s///qP/6geTCN+K1A/XKFHg7AP//7e3hcfnjV/v3sP//wP/+oPLe
XtuvAO3EIv/jSv/hOnc6AP//9P//8fjlXe/UNvLhfP/6oeLAJcOQAvraNP/nUP/tYP/mQXc5AP//
8//+5PfmdPLkf///sfbhWduzF/PSKP/pVNuyIvndRP/yaP/lPvfndu7bbP//xv//sv/9n//3hv/3
ff/3fPnpZd2wIf/mTv/lPfnsju7fdf//qf/8lf/5i//3f//1df/0af/zat+yHv7UIuWuSP76sf/9
lP/3eP/3cf/0Zv/wXv/tU//sTf/nQf/eO+a1F3o9AIJDAHk5AHc4AGs2AP///////////////ywA
AAAADwALAAAHoYAAAQKEA4YEBAUFBgcICQqQCgsMDQ4PEBESExQJFRYXCxgZGhsSHB0eHyAhIiMk
CiUmECcoKSorLC0hCi4vMDEPMjM0NTY3ODm7Ojs8PT4/QEFCQ0RFRiFHSElKS0xNTk9QUVJT1wpU
VVZXWFlaW1xdXl/JYGEyYjNjZGVmZ2hpalqsYdMmhZs3cOLImUNnSh07d/Dk0UPRiMWLOUDc2RMI
ADs=
"""
mail = PhotoImage(data=photo)
#
#
#
#header section for root window
f=Frame(root)
f.pack(fill=X, pady=10, padx=10)
w = Label(f, image=mail)
w.pack()
	
y = Label(f, text="Mailbox Notification Setup")
y.pack(pady=6)

ya = Label(f, wraplength=400, font="Courier 11", text="Fill in the values below \n*** NOT for use with GMAIL ***")
ya.pack(pady=2)

bGMAIL = Button(f, text="Setup Gmail", padx=12, command=run_gmail).pack(pady=18)

#
#inputs section
g=Frame(root)
g.pack(fill=X, pady=10, padx=10)

lblRadio = Label(g, text="Mail Server Type").grid(row=0, column=0)
radMailType=Radiobutton(g, text="pop3", variable=radVar, value="pop3").grid(row=0, column=1)
radMailType=Radiobutton(g, text="imap", variable=radVar, value="imap").grid(row=0, column=2)

lblUsername = Label(g,text="User Name:",pady=4).grid(row=1, column=0)
uname=Entry(g, textvariable=username, width=34).grid(row=1, column=1, columnspan=2)

lblPassword = Label(g,text="Password:",pady=4).grid(row=2, column=0)
p_word=Entry(g, textvariable=pword, width=34).grid(row=2, column=1, columnspan=2)

lblServer = Label(g,text="Server",pady=4).grid(row=3, column=0)
p_word=Entry(g, textvariable=servername, width=34).grid(row=3, column=1, columnspan=2)
lblServerDesc=Label(g, text="server example:").grid(row=4,column=0,columnspan=3)
lblServerDesc=Label(g, font="Courier 12", text="pop-server.rochester.rr.com").grid(row=5,column=0,columnspan=3)
#
#Sound section
sf=Frame(root, relief=RIDGE, borderwidth=2)
sf.pack(fill=X, pady=10, padx=10)

useSnd=Checkbutton(sf, text="Use An Alert", variable=sndBool, onvalue="on", offvalue="off", command=enableSound)
useSnd.grid(row=0, column=0, padx=12)
bSound=Button(sf,text="Change Sound" , state='disabled', command=findSound)
bSound.grid(row=0, column=1, pady=8, padx=12)
bTest=Button(sf, text="Test",  command=testSnd, state='disabled')
bTest.grid(row=0, column=2)
lblSound = Label(sf,textvariable=sndName,pady=4)
lblSound.grid(row=1, column=0, columnspan=2)
#

# Enable mail notification
e=Frame(root)
e.pack(fill=X, pady=10, padx=10)
lblmailNote = Label(e, text="Mail Notification").grid(row=0, column=0)
radmailNote=Radiobutton(e, text="Enable", variable=enVar, value="yes").grid(row=0, column=1)
radmailNote=Radiobutton(e, text="Disable", variable=enVar, value="no").grid(row=0, column=2)


#Command buttons
h=Frame(root)
h.pack(fill=X, pady=6, padx=10)
bCancel = Button(h, text="Cancel", padx=12, command=root.quit).grid(row=0, column=0, padx=10)
bApply = Button(h, text="Apply", padx=12, command=mValidate).grid(row=0, column=1, padx=10)
#
#
#
#then open the file and parse lines into "wholeStr" variable
#omitting the MailBoxPath so as to insert new value later
#Same goes for the NewMailCommand to play a sound
oldMailBoxPath = ""
oldNewMailCommand = ""
oldWav=""
wholeThing.set("")
try:
	f=open(mPath, 'r')
	for line in f.readlines():
		if string.find(line, "MailBoxPath") > -1:
			oldMailBoxPath=line
		elif string.find(line, "NewMailCommand") > -1:
			oldNewMailCommand=line
			mStart=string.find(oldNewMailCommand, "play ")
			if mStart > -1:
				mStart = mStart + 5
				mEnd=string.rfind(oldNewMailCommand, "\"")
				tmpWavStr=oldNewMailCommand[mStart: mEnd]
				if os.path.exists(tmpWavStr):
					oldWav=tmpWavStr
					sndBool.set("on")
					bSound.config(state="active")
					bTest.config(state="active")
					sndName.set(oldWav)
		else:
			wholeThing.set(wholeThing.get() + line)
	f.close()
except IOError:
	tkMessageBox.showwarning("Error Opening File\n\nMaybe it is open...\nAnyway, cannot edit it now.")
#
#
#parse the olMailBoxPath
if oldMailBoxPath=="":
	pass
else:
	s1=string.find(oldMailBoxPath,"\"") + 1
	s2=string.find(oldMailBoxPath,":")
	strSerType=oldMailBoxPath[s1: s2]
	radVar.set(strSerType)

	s1=string.find(oldMailBoxPath,"//") + 2
	s2=string.find(oldMailBoxPath,":",s1)
	strName=oldMailBoxPath[s1:s2]
	username.set(strName)

	s1=string.find(oldMailBoxPath,":",s1) + 1
	s2=string.find(oldMailBoxPath,"@")
	strPassword=oldMailBoxPath[s1:s2]
	pword.set(strPassword)

	s1=string.find(oldMailBoxPath,"@") + 1
	s2=string.rfind(oldMailBoxPath,"/")
	strServer=oldMailBoxPath[s1:s2]
	servername.set(strServer)
#
#
#Crank it up!
root.title("Email Taskbar Notification")
root.mainloop()
