#!/usr/bin/env python
#################################################################################
# c2008 by Paul Sherman <psherma1@rochester.rr.com> http://www.pcbypaul.com     #
#									        #
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 3		#
# 										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			#
# GNU General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public License		#
# along with this program; if not, write to the Free Software			#
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.   #
#################################################################################
import os, re, gtk, sys
#**************************************************************************************************************
#Color Dialog -- to set personal preference for ROX window BG color
#***********************************************************************************************************
def txt_bg_color():
	color = gtk.gdk.color_parse("blue")
	dialog = gtk.ColorSelectionDialog("Pick a color")
	#dialog.set_transient_for()
	colorsel = dialog.colorsel

	colorsel.set_previous_color(color)
	colorsel.set_current_color(color)
	colorsel.set_has_palette(True)

	response = dialog.run()

	if response == gtk.RESPONSE_OK:
		color = colorsel.get_current_color()
		cRGB = (color.red / 256,color.green / 256,color.blue / 256)
		hexcolor = '#%02x%02x%02x' % cRGB
		return hexcolor
	dialog.destroy()

if  len(sys.argv) > 1:
	if len(sys.argv[1]) == 6:
		bgcolor = "#" + sys.argv[1]
	elif len(sys.argv[1]) == 7:
		bgcolor = + sys.argv[1]
	else:	
		bgcolor = txt_bg_color()
else:	
	bgcolor = txt_bg_color()
	
	
if bgcolor == None:
	raise SystemExit
	
	
cTxt0 = """style "rox" = "default"
{
  bg[NORMAL] = """

cTxt1 = """
}
widget_class "*Collection*" style "rox"
"""
insTxt = cTxt0  + "\"" + bgcolor + "\"" + "\n  bg[ACTIVE] = \"" + bgcolor + "\"" + cTxt1
	
cfile = os.path.join(os.path.expanduser("~/"), ".gtkrc-2.0")

if not os.path.exists(cfile):
	try:
		file = open( cfile, 'w' )
		file.write( insTxt )
		file.close()
	except:
		print >> sys.stderr, "Cannot write configuration file to your home directory."
		raise SystemExit

whole = ""
foundflag = 0
file = open(cfile)
while 1:
	line = file.readline()
	if not line:
		break
	if re.match('style \"rox\"', line):
		foundflag = 1
		while not re.match('widget_class \"\*Collection\*\" style \"rox\"', line):
			line = file.readline()
		whole = whole + insTxt
		continue
	if line == "\n":
		continue
	whole = whole + line
if foundflag == 0:
	whole = whole + insTxt

file.close()

nfile = open(cfile, "w")
nfile.write(whole)
nfile.close()
	    
