#!/usr/bin/env python
#
# c2007-2009 by Paul Sherman <psherma1@rochester.rr.com> 
# http://www.pcbypaul.com 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3	
# of the License, or (at your option) any later version.
#
from Tkinter import *
import datetime, time, sys, os, commands, fcntl, tempfile, pyzenity

lockfile = os.path.normpath(os.getenv("HOME") + '/' + os.path.basename(__file__) + '.lock')
if os.path.exists(lockfile):
	 sys.exit()
	 
def callback():
	try:
		os.remove(lockfile)
	except:
		pass
	root.destroy()

def maxdays(mon,year):
		
	if mon==4 or mon==6 or mon==9 or mon==11 :
		return 30
	
	if mon==2 :
		if year%4==0 and (year%100!=0 or year%400==0): return 29
		return 28
	else :
		return 31    
			

def setTheDate():
	#mth, dy, yr, hr, min
	
	mRange=test.listYear.yview()
	mSpot = int(((mRange[0] + mRange[1]) / 2) * 96)
	yr = test.listYear.get(mSpot)
	
	mRange=test.listDay.yview()
	mSpot = int(((mRange[0] + mRange[1]) / 2) * 31)
	dy = test.listDay.get(mSpot)
	
	mRange=test.listMonth.yview()
	mSpot = int(((mRange[0] + mRange[1]) / 2) * 12)
	mth = test.listMonth.get(mSpot)
	
	if dy > maxdays(mth, yr):
		pyzenity.InfoMessage("\nBad Date\n\nThe currently selected month does not have " + repr(dy) + " days")
		return 0
	else:
		pass
		
	mRange=test.listHours.yview()
	mSpot = int(((mRange[0] + mRange[1]) / 2) * 13)
	intHr = int(test.listHours.get(mSpot)) + int(radVar.get())
	#ensures a switch from am to pm does not put us into 24:15 land...
	if intHr > 23:
		intHr = intHr - 12
	hr = intHr
	
	mRange=test.listMinutes.yview()
	mSpot = int(((mRange[0] + mRange[1]) / 2) * 60)
	min = test.listMinutes.get(mSpot)
	
	strDate = "%02i/%02i/%4i %02i:%02i:00" % (mth, dy, yr,hr,min)
	bareDate = "%02i/%02i/%4i" % (mth, dy, yr)
	bareTime = "%02i:%02i:00" % (hr,min)
	
	cmdDate="/usr/bin/date -s \"" + strDate + "\""
	cmdRTC="/sbin/hwclock --systohc"
	cmdSUDate="sudo /usr/bin/date -s \"" + strDate + "\""
	cmdSURTC="sudo /sbin/hwclock --systohc"

	try:
		if os.getuid() == 0: 
			status = os.system(cmdDate)
			status = os.system(cmdRTC)
		else:
			status = os.system(cmdSUDate)
			status = os.system(cmdSURTC)
			
		pyzenity.InfoMessage("\nDesktop and RTC clock set to:\n" + strDate + "\n")
		
	except:
		pass
		
	os.remove(lockfile)
	root.destroy()

def syncOnline():

	if not os.path.exists("/usr/sbin/ntpdate"):
		pyzenity.InfoMessage("Sorry, but the required \"ntpdate\" utility seems to be missing...")
		return 0
	cmdSync='/usr/sbin/ntpdate -sb time.nist.gov | zenity --progress --width=300 --title="Attempting to sync time..."'
	cmdSUSync='sudo /usr/sbin/ntpdate -sb time.nist.gov | zenity --progress --width=300 --title="Attempting to sync time..."'
	try:
		if os.getuid() == 0: 
			status = os.system(cmdSync)
		else:
			status = os.system(cmdSUSync)

	except:
		pyzenity.InfoMessage("\nThere was an error attempting to sync clock to NTP time server.\n")
		
	os.remove(lockfile)
	root.destroy()

			
	
class Test(Frame):
		
	def createWidgets(self):
	
		self.lblHeader = Label(self, text="Adjusts System Clock and the RTC")
		self.lblHeader.pack(padx=10, pady=6)
	
		frameDate = Frame(self, relief=RAISED, borderwidth=1, background="#cccccc")
		frameDate.pack(padx=12)
		
		#Widgets for month
		fmonth = Frame(frameDate, relief=RIDGE, borderwidth=2)
		fmonth.grid(row=0, column=0, padx=6, pady=6)
		
		self.lblMonth = Label(fmonth, text="month")
		self.lblMonth.grid(row=0, column=0)
		
		self.listMonth = Listbox(fmonth, height=1, width=6)
		self.listMonth.grid(row=1, column=0)
		
		self.scrollMonth = Scrollbar(fmonth)
		self.scrollMonth.grid(rowspan=2, row=0, column=1)

		#Range and bindings fot month
		for i in range(12, 0, -1):
			self.listMonth.insert(END, i)
			self.listMonth.yview(abs(int(now.month)-12))
			
		self.listMonth.config(yscrollcommand=self.scrollMonth.set)
		self.scrollMonth.config(command=self.listMonth.yview)
		
		#Widgets for day
		frameDay = Frame(frameDate, relief=RIDGE, borderwidth=2)
		frameDay.grid(row=0, column=1, padx=6, pady=6)
		
		self.lblDay = Label(frameDay, text="day")
		self.lblDay.grid(row=0, column=0)
		
		self.listDay = Listbox(frameDay, height=1, width=6)
		self.listDay.grid(row=1, column=0)
		
		self.scrollDay = Scrollbar(frameDay)
		self.scrollDay.grid(rowspan=2, row=0, column=1)

		#Range and Bindings for Minutes
		for j in range(31, 0, -1):
			self.listDay.insert(END, j)
			self.listDay.yview(abs(int(now.day)-31))
			
		self.listDay.config(yscrollcommand=self.scrollDay.set)
		self.scrollDay.config(command=self.listDay.yview)
		
		#Widgets for year
		frameYear = Frame(frameDate, relief=RIDGE, borderwidth=2)
		frameYear.grid(row=0, column=2, padx=6, pady=6)
		
		self.lblYear = Label(frameYear, text="year")
		self.lblYear.grid(row=0, column=0)
		
		self.listYear = Listbox(frameYear, height=1, width=6)
		self.listYear.grid(row=1, column=0)
		
		self.scrollYear = Scrollbar(frameYear)
		self.scrollYear.grid(rowspan=2, row=0, column=1)

		#Range and Bindings for Minutes
		for j in range(2099, 2003, -1):
			self.listYear.insert(END, j)
			self.listYear.yview(abs(int(now.year)-2099))
			
		self.listYear.config(yscrollcommand=self.scrollYear.set)
		self.scrollYear.config(command=self.listYear.yview)
		
		fSettings = Frame(self, relief=SUNKEN, borderwidth=1, background="#cccccc")
		fSettings.pack(pady=12)
		
		#Widgets for Hours
		fh = Frame(fSettings, relief=RIDGE, borderwidth=2)
		fh.grid(row=0, column=0, padx=6, pady=6)
		
		self.lblHours = Label(fh, text="hour")
		self.lblHours.grid(row=0, column=0)
		
		self.listHours = Listbox(fh, height=1, width=6)
		self.listHours.grid(row=1, column=0)
		
		self.scrollHours = Scrollbar(fh)
		self.scrollHours.grid(rowspan=2, row=0, column=1)

		#Range and bindings fot Hours
		for i in range(12, -1, -1):
			self.listHours.insert(END, i)
			self.listHours.yview(abs(intHour-12))
			
		self.listHours.config(yscrollcommand=self.scrollHours.set)
		self.scrollHours.config(command=self.listHours.yview)
		
		#Widgets for Minutes
		fm = Frame(fSettings, relief=RIDGE, borderwidth=2)
		fm.grid(row=0, column=1, padx=6, pady=6)
		
		self.lblMinutes = Label(fm, text="minute")
		self.lblMinutes.grid(row=0, column=0)
		
		self.listMinutes = Listbox(fm, height=1, width=6)
		self.listMinutes.grid(row=1, column=0)
		
		self.scrollMinutes = Scrollbar(fm)
		self.scrollMinutes.grid(rowspan=2, row=0, column=1)

		#Range and Bindings for Minutes
		for j in range(59, -1, -1):
			self.listMinutes.insert(END, j)
			self.listMinutes.yview(abs(int(now.minute)-59))
			
		self.listMinutes.config(yscrollcommand=self.scrollMinutes.set)
		self.scrollMinutes.config(command=self.listMinutes.yview)
		
		# Radio Buttons for AM/PM
		fAmPm = Frame(fSettings, relief=RIDGE, borderwidth=2)
		fAmPm.grid(row=0, column=2, padx=6, pady=6)
		
		self.radioAmPm = Radiobutton(fAmPm, text="am", variable=radVar, value="0")
		self.radioAmPm.grid(row=0, column=0)
		self.radioAmPm = Radiobutton(fAmPm, text="pm", variable=radVar, value="12")
		self.radioAmPm.grid(row=1, column=0)
		
		btnFrame = Frame(self)
		btnFrame.pack(fill=X, pady=2)
		bCancel = Button(btnFrame, text="Close", padx=12, command=callback).grid(row=0, column=0, padx=10)
		bApply = Button(btnFrame, text="Apply", padx=12, command=setTheDate).grid(row=0, column=1, padx=10)
		bNTPdate = Button(btnFrame, text="SyncOnline", padx=12, command=syncOnline).grid(row=0, column=2, padx=10)
		
	def __init__(self, master=None):
		Frame.__init__(self, master)
		Pack.config(self)
		self.createWidgets()
		

root = Tk()
root.protocol("WM_DELETE_WINDOW", callback)

fp = open(lockfile, 'w')
try:
	fcntl.lockf(fp, fcntl.LOCK_EX | fcntl.LOCK_NB)
except IOError:
	callback
	
now = datetime.datetime.now()
radVar = StringVar()
strYear = repr(now.year)
strMonth = repr(now.month)
strDay = repr(now.day)
strYear = repr(now.minute)
tmpHour = int(now.hour)
if tmpHour >= 12:
	intHour = abs(int(now.hour) - 12)
	radVar.set("12")
else:
	intHour = int(now.hour)
	radVar.set("0")
	
test = Test()
	
# routine to center root window  on screen
scrX, scrY = root.winfo_screenwidth(), root.winfo_screenheight()
wStart = (scrX - 300) / 2
hStart = (scrY - 220) / 2
root.geometry("%dx%d%+d%+d" % (300, 220, wStart, hStart))
root.title("Absolute Time :)")

#test for valid date
maxDate = maxdays(2,2004)

###############
test.mainloop()
