#!/usr/bin/env python
#
# absServices.py
# c2007-2015 by Paul Sherman   http://www.pcbypaul.com
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or (at your option) any later version.
#
import pygtk
pygtk.require('2.0')
import gtk, sys, os
try:
	import pango
except:
	print >> sys.stderr, "Cannot load Pango"
	raise SystemExit
default_font = "unknown"
fsize = 10
font_desc = pango.FontDescription()
icon_xpm = [
"16 16 117 2",
"  	c #FFFC00",
". 	c #B0B200",
"+ 	c #005D98",
"@ 	c #005F9C",
"# 	c #AEB000",
"$ 	c #E1E400",
"% 	c #DEDB00",
"& 	c #539A00",
"* 	c #85CDFF",
"= 	c #9BD3FF",
"- 	c #5BA200",
"; 	c #E2DF00",
"> 	c #DDE000",
", 	c #B7DE00",
"' 	c #006ABC",
") 	c #006E9C",
"! 	c #006CB0",
"~ 	c #65BCFF",
"{ 	c #63BBFF",
"] 	c #81C5FF",
"^ 	c #BDE2FF",
"/ 	c #0073BC",
"( 	c #0074A4",
"_ 	c #007CDC",
": 	c #B4D400",
"< 	c #E8E500",
"[ 	c #0082AC",
"} 	c #5BB8FF",
"| 	c #77C4FF",
"1 	c #51B3FF",
"2 	c #69BEFF",
"3 	c #71C5FF",
"4 	c #97CFFF",
"5 	c #9FD5FF",
"6 	c #B3E3FF",
"7 	c #078EAB",
"8 	c #727C00",
"9 	c #43ADFF",
"0 	c #4FB2FF",
"a 	c #078DFF",
"b 	c #0085EC",
"c 	c #0F97FF",
"d 	c #8BCDFF",
"e 	c #A3D3FF",
"f 	c #7A8200",
"g 	c #12866C",
"h 	c #2BA3FF",
"i 	c #006CC8",
"j 	c #1DA2FF",
"k 	c #59B7FF",
"l 	c #0079E0",
"m 	c #6DC3FF",
"n 	c #16865D",
"o 	c #B5BC00",
"p 	c #005682",
"q 	c #35ACFF",
"r 	c #008FFE",
"s 	c #5DB8FF",
"t 	c #0081A6",
"u 	c #A09E00",
"v 	c #969400",
"w 	c #058FCF",
"x 	c #3BAEFF",
"y 	c #005886",
"z 	c #838800",
"A 	c #79C8FF",
"B 	c #33A6FF",
"C 	c #1D9DFF",
"D 	c #0088F0",
"E 	c #3FB0FF",
"F 	c #828A00",
"G 	c #708C00",
"H 	c #3BAAFF",
"I 	c #008AF4",
"J 	c #8C8E00",
"K 	c #8A8C00",
"L 	c #1B9CFF",
"M 	c #258D31",
"N 	c #1C927A",
"O 	c #239FFF",
"P 	c #909200",
"Q 	c #F0ED00",
"R 	c #527400",
"S 	c #007EB2",
"T 	c #179AFF",
"U 	c #005DB4",
"V 	c #0068AA",
"W 	c #006DB2",
"X 	c #0060B2",
"Y 	c #0391FF",
"Z 	c #47AFFF",
"` 	c #0076A2",
" .	c #0077DC",
"..	c #27A1FF",
"+.	c #006AC4",
"@.	c #777E00",
"#.	c #004F70",
"$.	c #B1DFFF",
"%.	c #39A9FF",
"&.	c #008DFA",
"*.	c #004E68",
"=.	c #197123",
"-.	c #D9F4F5",
";.	c #81C8FF",
">.	c #4FBBFF",
",.	c #337507",
"'.	c #5B6E00",
").	c #929000",
"!.	c #848200",
"~.	c #37B6FF",
"{.	c #40C2F8",
"].	c #8C8A00",
"^.	c #5B6C00",
"/.	c #088492",
"(.	c #3A7000",
"_.	c #DAD700",
":.	c #4E7200",
"            . + @ #             ",
"        $ % & * = - ; >         ",
"    , ' ) ! ~ { ] ^ / ( _ :     ",
"  < [ } * * | 1 2 3 4 5 6 7     ",
"    8 1 9 0 a b c 9 d d e f     ",
"    g 0 h i 0 j k e l m 4 n     ",
"o p q 9 r s t u v w * a { x y # ",
"z A B C D E F     G H I 1 0 ] J ",
"K s h L D A M     N ~ i O 0 0 P ",
"Q R S } T d U V W X 2 Y Z ` R Q ",
"    8 5 s  .| C ..0 +.h 0 @.    ",
"    #.$.* %.&.&.&.&.Y s s *.    ",
"    =.-.* ;.~ O h 1 0 >.~ ,.    ",
"    Q '.).!.~.0 0 {.].].^.Q     ",
"            /.s } (.            ",
"            _.:.:._.            "
]

class ServicesList:

	def __init__(self):
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_title("Services Menu")
		self.window.set_size_request(340, 500)
		self.window.set_position(gtk.WIN_POS_CENTER)
		self.window.connect("delete_event", self.delete_event)

		icon = gtk.gdk.pixbuf_new_from_xpm_data(icon_xpm)
		self.window.set_icon(icon)
		y_placement = 60

		table = gtk.Table(2, 2, False)
		self.window.add(table)
		self.layout = gtk.Layout(None, None)
		self.layout.set_size(600, 600)
		self.layout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#DCDCDC"))
		table.attach(self.layout, 0, 1, 0, 1, gtk.FILL|gtk.EXPAND, gtk.FILL|gtk.EXPAND, 0, 0)	     
		vScrollbar = gtk.VScrollbar(None)
		table.attach(vScrollbar, 1, 2, 0, 1, gtk.FILL|gtk.SHRINK, gtk.FILL|gtk.SHRINK, 0, 0)		     
		vAdjust = self.layout.get_vadjustment()
		vScrollbar.set_adjustment(vAdjust)
		lbl_font_face = gtk.Label("Select Services")
		self.layout.put(lbl_font_face, 30, 12)
		lbl_font_face.modify_font(pango.FontDescription('Aerial'))
		lbl_font_face.set_justify(gtk.JUSTIFY_CENTER)
		lbl_font_face.set_markup('<span size="16000" foreground="#22518E"><b>Select Services</b>\nto run on system startup</span>')


		if os.access("/etc/rc.d/rc.cups", os.R_OK):
			y_placement = y_placement + 24
			self.cb3 = gtk.CheckButton(label=" CUPS print server")
			self.layout.put(self.cb3, 12, y_placement)
			self.cb3.set_tooltip_text('The Common UNIX Printing system. \nIf you have a printer connected, you will want this.')	 
			self.cups_state = False
			if os.access("/etc/rc.d/rc.cups", os.X_OK):
				self.cb3.set_active(True)
				self.cups_state = True
			self.cb3.connect("toggled", self.SetState, self.cups_state)
			
		if os.access("/etc/rc.d/rc.networkmanager", os.R_OK):
			y_placement = y_placement + 24
			self.cb4 = gtk.CheckButton(label=" Network Manager")
			self.layout.put(self.cb4, 12, y_placement)
			self.cb4.set_tooltip_text('Needed for wireless hookups,\n also used by default on Absolute to control wired connections.')	 
			self.nm_state = False
			if os.access("/etc/rc.d/rc.networkmanager", os.X_OK):
				self.cb4.set_active(True)
				self.nm_state = True
			self.cb4.connect("toggled", self.SetState, self.nm_state)		
		
		if os.access("/etc/rc.d/rc.bind", os.R_OK):
			y_placement = y_placement + 24
			self.cb5 = gtk.CheckButton(label=" BIND server")
			self.layout.put(self.cb5, 12, y_placement)
			self.cb5.set_tooltip_text('BIND (Berkeley Internet Name Domain)\nis a Domain Name System (DNS) server.')	 
			self.bind_state = False
			if os.access("/etc/rc.d/rc.bind", os.X_OK):
				self.cb5.set_active(True)
				self.bind_state = True
			self.cb5.connect("toggled", self.SetState, self.bind_state)		
				
		if os.access("/etc/rc.d/rc.dnsmasq", os.R_OK):
			y_placement = y_placement + 24
			self.cb6 = gtk.CheckButton(label=" dnsmasq DHCP/DNS server")
			self.layout.put(self.cb6, 12, y_placement)
			self.cb6.set_tooltip_text('DNS forwarder and DHCP server.\n[Not needed for a client -- for example, to connect to cable internet service.]')	 
			self.dnsmasq_state = False
			if os.access("/etc/rc.d/rc.dnsmasq", os.X_OK):
				self.cb6.set_active(True)
				self.dnsmasq_state = True
			self.cb6.connect("toggled", self.SetState, self.dnsmasq_state)
							
		if os.access("/etc/rc.d/rc.httpd", os.R_OK):
			y_placement = y_placement + 24
			self.cb7 = gtk.CheckButton(label=" The Apache web server")
			self.layout.put(self.cb7, 12, y_placement)
			self.cb7.set_tooltip_text('Apache, the most widely used web server on the net.')	 
			self.httpd_state = False
			if os.access("/etc/rc.d/rc.httpd", os.X_OK):
				self.cb7.set_active(True)
				self.httpd_state = True
			self.cb7.connect("toggled", self.SetState, self.httpd_state)

		if os.access("/etc/rc.d/rc.inetd", os.R_OK):
			y_placement = y_placement + 24
			self.cb8 = gtk.CheckButton(label=" The BSD Inetd daemon")
			self.layout.put(self.cb8, 12, y_placement)
			self.cb8.set_tooltip_text('Inetd daemon (this allows:  time, ftp, wx.comsat, talk, finger, and auth).')	 
			self.inetd_state = False
			if os.access("/etc/rc.d/rc.inetd", os.X_OK):
				self.cb8.set_active(True)
				self.inetd_state = True
			self.cb8.connect("toggled", self.SetState, self.inetd_state)

		if os.access("/etc/rc.d/rc.ip_forward", os.R_OK):
			y_placement = y_placement + 24
			self.cb9 = gtk.CheckButton(label=" Activate IP packet forwarding")
			self.layout.put(self.cb9, 12, y_placement)
			self.cb9.set_tooltip_text('Packet forwarding allows your Linux machine to act as a router.')	 
			self.ip_forward_state = False
			if os.access("/etc/rc.d/rc.ip_forward", os.X_OK):
				self.cb9.set_active(True)
				self.ip_forward_state = True
			self.cb9.connect("toggled", self.SetState, self.ip_forward_state)			
											
		if os.access("/etc/rc.d/rc.mysqld", os.R_OK):
			y_placement = y_placement + 24
			self.cb10 = gtk.CheckButton(label=" The MySQL database server")
			self.layout.put(self.cb10, 12, y_placement)
			self.cb10.set_tooltip_text('MySQL, an SQL-based relational database daemon.')	 
			self.mysqld_state = False
			if os.access("/etc/rc.d/rc.mysqld", os.X_OK):
				self.cb10.set_active(True)
				self.mysqld_state = True
			self.cb10.connect("toggled", self.SetState, self.mysqld_state)

		if os.access("/etc/rc.d/rc.pcmcia", os.R_OK):
			y_placement = y_placement + 24
			self.cb11 = gtk.CheckButton(label=" PCMCIA/Cardbus card services")
			self.layout.put(self.cb11, 12, y_placement)
			self.cb11.set_tooltip_text('This supports PCMCIA or Cardbus cards used with laptops.')	 
			self.pcmcia_state = False
			if os.access("/etc/rc.d/rc.pcmcia", os.X_OK):
				self.cb11.set_active(True)
				self.pcmcia_state = True
			self.cb11.connect("toggled", self.SetState, self.pcmcia_state)

		if os.access("/etc/rc.d/rc.rpc", os.R_OK):
			y_placement = y_placement + 24
			self.cb12 = gtk.CheckButton(label=" NFS (Network FileSystem) daemon")
			self.layout.put(self.cb12, 12, y_placement)
			self.cb12.set_tooltip_text('Needed to serve or mount NFS (Network File System) partitions.')	 
			self.rpc_state = False
			if os.access("/etc/rc.d/rc.rpc", os.X_OK):
				self.cb12.set_active(True)
				self.rpc_state = True
			self.cb12.connect("toggled", self.SetState, self.rpc_state)

		if os.access("/etc/rc.d/rc.samba", os.R_OK):
			y_placement = y_placement + 24
			self.cb13 = gtk.CheckButton(label=" The Samba file/print server")
			self.layout.put(self.cb13, 12, y_placement)
			self.cb13.set_tooltip_text('Samba is a file and print server for Windows networks.')	 
			self.samba_state = False
			if os.access("/etc/rc.d/rc.samba", os.X_OK):
				self.cb13.set_active(True)
				self.samba_state = True
			self.cb13.connect("toggled", self.SetState, self.samba_state)
			
		if os.access("/etc/rc.d/rc.saslauthd", os.R_OK):
			y_placement = y_placement + 24
			self.cb14 = gtk.CheckButton(label=" The SASL authentication server")
			self.layout.put(self.cb14, 12, y_placement)
			self.cb14.set_tooltip_text('SASL is an authentication method often used by mail servers.')	 
			self.saslauthd_state = False
			if os.access("/etc/rc.d/rc.saslauthd", os.X_OK):
				self.cb14.set_active(True)
				self.saslauthd_state = True
			self.cb14.connect("toggled", self.SetState, self.saslauthd_state)						

		if os.access("/etc/rc.d/rc.sendmail", os.R_OK):
			y_placement = y_placement + 24
			self.cb15 = gtk.CheckButton(label=" The Sendmail mail server")
			self.layout.put(self.cb15, 12, y_placement)
			self.cb15.set_tooltip_text('The Sendmail server allows your machine to send and receive mail.\nNOT needed if you use a mail client (such as Sylpheed or Firebird) to send and recieve mail from your ISP.')	 
			self.sendmail_state = False
			if os.access("/etc/rc.d/rc.sendmail", os.X_OK):
				self.cb15.set_active(True)
				self.sendmail_state = True
			self.cb15.connect("toggled", self.SetState, self.sendmail_state)						
						

		if os.access("/etc/rc.d/rc.syslog", os.R_OK):
			y_placement = y_placement + 24
			self.cb16 = gtk.CheckButton(label=" The Linux system logging utilities")
			self.layout.put(self.cb16, 12, y_placement)
			self.cb16.set_tooltip_text('The syslogd and klogd daemons log important messages under /var/log.')	 
			self.syslog_state = False
			if os.access("/etc/rc.d/rc.syslog", os.X_OK):
				self.cb16.set_active(True)
				self.syslog_state = True
			self.cb16.connect("toggled", self.SetState, self.syslog_state)
			
		if os.access("/etc/rc.d/rc.sshd", os.R_OK):
			y_placement = y_placement + 24
			self.cb17 = gtk.CheckButton(label=" The SSHD (secure shell) daemon")
			self.layout.put(self.cb17, 12, y_placement)
			self.cb17.set_tooltip_text('The SSHD (secure shell) daemon" $RC_SSHD "SSHD allows secure encrypted logins to your machine.')	 
			self.sshd_state = False
			if os.access("/etc/rc.d/rc.sshd", os.X_OK):
				self.cb17.set_active(True)
				self.sshd_state = True
			self.cb17.connect("toggled", self.SetState, self.sshd_state)
						
		if os.access("/usr/sbin/crond", os.R_OK):
			y_placement = y_placement + 24
			self.cb18 = gtk.CheckButton(label=" crond command daemon")
			self.layout.put(self.cb18, 12, y_placement)
			self.cb18.set_tooltip_text('crond - daemon to execute scheduled commands.')	 
			self.crond_state = False
			if os.access("/usr/sbin/crond", os.X_OK):
				self.cb18.set_active(True)
				self.crond_state = True
			self.cb18.connect("toggled", self.SetState, self.crond_state)

		if os.access("/usr/sbin/atd", os.R_OK):
			y_placement = y_placement + 24
			self.cb19 = gtk.CheckButton(label=" atd command daemon")
			self.layout.put(self.cb19, 12, y_placement)
			self.cb19.set_tooltip_text('atd - daemon to execute scheduled commands.')	 
			self.atd_state = False
			if os.access("/usr/sbin/atd", os.X_OK):
				self.cb19.set_active(True)
				self.atd_state = True
			self.cb19.connect("toggled", self.SetState, self.atd_state)	

		if os.access("/usr/sbin/atalk", os.R_OK):
			y_placement = y_placement + 24
			self.cb20 = gtk.CheckButton(label=" Netatalk Appletalk file/print server")
			self.layout.put(self.cb20, 12, y_placement)
			self.cb20.set_tooltip_text('The Netatalk server is a file and print server for Macintosh networks.')	 
			self.atalk_state = False
			if os.access("/usr/sbin/atalk", os.X_OK):
				self.cb20.set_active(True)
				self.atalk_state = True
			self.cb19.connect("toggled", self.SetState, self.atalk_state)
						
						
		self.btn_box = gtk.HBox(True, 0)
		self.close_btn = gtk.Button(" Close ")
		self.apply_btn = gtk.Button(" Apply ")
		self.btn_box.pack_start(self.close_btn, False, False, 12)	
		self.btn_box.pack_start(self.apply_btn, False, False, 12)	
		self.close_btn.connect("clicked", self.delete_event)
		self.apply_btn.connect("clicked", self.ApplyChanges)

		self.close_btn.get_children()[0].modify_font(pango.FontDescription('Aerial Bold 14'))
		self.apply_btn.get_children()[0].modify_font(pango.FontDescription('Aerial Bold 14'))
		self.close_btn.get_children()[0].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#22518E"))
		self.close_btn.get_children()[0].modify_fg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("#DD0000"))
		self.close_btn.get_children()[0].modify_fg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("#DD0000"))
		self.apply_btn.get_children()[0].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#22518E"))
		self.apply_btn.get_children()[0].modify_fg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("#DD0000"))
		self.apply_btn.get_children()[0].modify_fg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("#DD0000"))
		
		self.apply_btn.set_sensitive(0)
		self.layout.put(self.btn_box, 40, y_placement + 50)

        	self.window.show_all()


	def delete_event(self, window=None, event=None):
		gtk.main_quit()


	def SetState(self, event, state):
		if (event.get_active() != state):
			event.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#FF0000"))
			event.modify_fg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("#FF0000"))
			event.modify_fg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("#FF0000"))
		else:
			event.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#000000"))
			event.modify_fg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("#000000"))
			event.modify_fg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("#000000"))

		try:
		
			for kid in self.layout.get_children():
				col = kid.style.fg[gtk.STATE_NORMAL].to_string()
				if col.startswith("#ff"):
					self.apply_btn.set_sensitive(1)
					break
				else:
					self.apply_btn.set_sensitive(0)
		except:
			box = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, '\npyGTK 2.12 (or greater) is required for this application.')
			box.set_position(gtk.WIN_POS_CENTER)
			box.set_title('Program failure')
			box.run()
			box.destroy()	
			self.delete_event()
		
	
	def ApplyChanges(self, event):
	



		try:
			if self.cb3.get_active() != self.cups_state:
				if self.cb3.get_active() == True:
					os.chmod("/etc/rc.d/rc.cups", 0755)
				else:
					os.chmod("/etc/rc.d/rc.cups", 0644)
		except:
			pass	
			
		try:
			if self.cb4.get_active() != self.nm_state:
				if self.cb4.get_active() == True:
					os.chmod("/usr/bin/nm-applet", 0755)
					os.chmod("/etc/rc.d/rc.networkmanager", 0755)
					os.system("echo 'deathstar.absolute.net' > /etc/HOSTNAME")
					os.system("echo '127.0.0.1	localhost' > /etc/hosts")
					os.system("echo '127.0.0.1	deathstar.absolute.net	deathstar' >> /etc/hosts")
				else:
					os.chmod("/usr/bin/nm-applet", 0644)
					os.chmod("/etc/rc.d/rc.networkmanager", 0644)
		except:
			pass	

		
		try:
			if self.cb5.get_active() != self.bind_state:
				if self.cb5.get_active() == True:
					os.chmod("/etc/rc.d/rc.bind", 0755)
				else:
					os.chmod("/etc/rc.d/rc.bind", 0644)
		except:
			pass	
			
		try:
			if self.cb6.get_active() != self.bind_state:
				if self.cb6.get_active() == True:
					os.chmod("/etc/rc.d/rc.dnsmasq", 0755)
				else:
					os.chmod("/etc/rc.d/rc.dnsmasq", 0644)
		except:
			pass	
			
		try:
			if self.cb7.get_active() != self.httpd_state:
				if self.cb7.get_active() == True:
					os.chmod("/etc/rc.d/rc.httpd", 0755)
				else:
					os.chmod("/etc/rc.d/rc.httpd", 0644)
		except:
			pass												

		try:
			if self.cb8.get_active() != self.inetd_state:
				if self.cb8.get_active() == True:
					os.chmod("/etc/rc.d/rc.inetd", 0755)
				else:
					os.chmod("/etc/rc.d/rc.inetd", 0644)
		except:
			pass												


		try:
			if self.cb9.get_active() != self.ip_forward_state:
				if self.cb9.get_active() == True:
					os.chmod("/etc/rc.d/rc.ip_forward", 0755)
				else:
					os.chmod("/etc/rc.d/rc.ip_forward", 0644)
		except:
			pass												

		try:
			if self.cb10.get_active() != self.mysqld_state:
				if self.cb10.get_active() == True:
					os.chmod("/etc/rc.d/rc.mysqld", 0755)
				else:
					os.chmod("/etc/rc.d/rc.mysqld", 0644)
		except:
			pass												

		try:
			if self.cb11.get_active() != self.pcmcia_state:
				if self.cb11.get_active() == True:
					os.chmod("/etc/rc.d/rc.pcmcia", 0755)
				else:
					os.chmod("/etc/rc.d/rc.pcmcia", 0644)
		except:
			pass												

		try:
			if self.cb12.get_active() != self.rpc_state:
				if self.cb12.get_active() == True:
					os.chmod("/etc/rc.d/rc.rpc", 0755)
					os.chmod("/etc/rc.d/rc.nfsd", 0755)
				else:
					os.chmod("/etc/rc.d/rc.rpc", 0644)
					os.chmod("/etc/rc.d/rc.rnfsd", 0644)
		except:
			pass												

		try:
			if self.cb13.get_active() != self.samba_state:
				if self.cb13.get_active() == True:
					os.chmod("/etc/rc.d/rc.samba", 0755)
				else:
					os.chmod("/etc/rc.d/rc.samba", 0644)
		except:
			pass												

		try:
			if self.cb14.get_active() != self.saslauthd_state:
				if self.cb14.get_active() == True:
					os.chmod("/etc/rc.d/rc.saslauthd", 0755)
				else:
					os.chmod("/etc/rc.d/rc.saslauthd", 0644)
		except:
			pass												

		try:
			if self.cb15.get_active() != self.sendmail_state:
				if self.cb15.get_active() == True:
					os.chmod("/etc/rc.d/rc.sendmail", 0755)
				else:
					os.chmod("/etc/rc.d/rc.sendmail", 0644)
		except:
			pass												

		try:
			if self.cb16.get_active() != self.syslog_state:
				if self.cb16.get_active() == True:
					os.chmod("/etc/rc.d/rc.syslog", 0755)
				else:
					os.chmod("/etc/rc.d/rc.syslog", 0644)
		except:
			pass												

		try:
			if self.cb17.get_active() != self.sshd_state:
				if self.cb17.get_active() == True:
					os.chmod("/etc/rc.d/rc.sshd", 0755)
				else:
					os.chmod("/etc/rc.d/rc.sshd", 0644)
		except:
			pass	
			
		try:
			if self.cb18.get_active() != self.crond_state:
				if self.cb18.get_active() == True:
					os.chmod("/usr/sbin/crond", 0755)
				else:
					os.chmod("/usr/sbin/crond", 0644)
		except:
			pass				

		try:
			if self.cb19.get_active() != self.atd_state:
				if self.cb19.get_active() == True:
					os.chmod("/usr/sbin/atd", 0755)
				else:
					os.chmod("/usr/sbin/atd", 0644)
		except:
			pass	

		try:
			if self.cb20.get_active() != self.atalk_state:
				if self.cb20.get_active() == True:
					os.chmod("/usr/sbin/atalk", 0755)
				else:
					os.chmod("/usr/sbin/atalk", 0644)
		except:
			pass	
			
			
		box = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, '\nThe changes have been applied.')
		box.set_position(gtk.WIN_POS_CENTER)
		box.set_title('Changes made to services')
		box.run()
		box.destroy()	
		self.delete_event()
		

def main():
    # enter the main loop
    gtk.main()
    return 0

if __name__ == "__main__":
    ServicesList()
    main()
